package controllers

import (
	"hongze/hongze_mobile_admin/services"
)

// VarietyTagController 标签库
type VarietyTagController struct {
	BaseAuth
}

// TagTree
// @Title 标签树
// @Description 标签树
// @Success 200 string "获取成功"
// @router /variety_tag/tag_tree [get]
func (c *VarietyTagController) TagTree() {
	// 是否包含被禁用的研究员标签
	include, _ := c.GetInt("IncludeDisableMember")
	resp, e := services.GetTagTree(include)
	if e != nil {
		c.FailWithMessage("获取失败", "TagTree-获取标签树失败, Err: "+e.Error())
		return
	}
	c.OkDetailed(resp, "获取成功")
}
