package contract

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hongze_mobile_admin/models/tables/contract"
	"hongze/hongze_mobile_admin/models/tables/contract_approval"
	"hongze/hongze_mobile_admin/models/tables/contract_approval_record"
	"time"
)

type ContractListResp struct {
	Paging *paging.PagingItem
	List   []*contract.ContractList `description:"列表数据"`
}

type ContractListRespV2 struct {
	Paging *paging.PagingItem
	List   []*contract_approval.ContractApprovalList `description:"列表数据"`
}

type ContractOperationRecordListResp struct {
	Id               int       ``
	ContractId       int       `description:"合同id"`
	Operation        string    `description:"操作类型，add：新增，edit：编辑，apply：发起审批，cancel_apply：撤回审批，reject：拒绝审批，approval：审批操作;长度36位"`
	OpUserId         int       `description:"操作人id"`
	OpUserName       string    `description:"操作人名称"`
	Remark           string    `description:"备注，长度255位"`
	ApprovalRecordId int       `orm:"column(approval_record_id)" description:"审批流id"`
	CreateTime       time.Time `description:"日志添加时间"`
	CreateTimeStr    string    `description:"日志添加时间"`
}

//审批列表
type ContractApprovalListResp struct {
	Paging *paging.PagingItem
	List   []*contract_approval.ContractApprovalList `description:"列表数据"`
}

//审批列表
type ContractDetailResp struct {
	ContractDetail *contract.ContractDetail                            `description:"审批单详情"`
	FlowNodeList   [][]contract_approval_record.ContractApprovalRecord `description:"审批流"`
	OpButton       OpButton                                            `description:"操作权限"`
}

//合同操作按钮
type OpButton struct {
	Approval   bool `description:"是否有审批权限"`
	UploadFile bool `description:"是否有上传签回文件权限"`
	Invalid    bool `description:"是否有作废合同权限"`
}
