package seal

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hongze_mobile_admin/models/tables/contract_approval"
	"hongze/hongze_mobile_admin/models/tables/contract_approval_record"
	"hongze/hongze_mobile_admin/models/tables/seal"
)

//AddSealResp 新增用印返回
type AddSealResp struct {
	SealId int `description:"用印id"`
}

//SealApprovalListResp 审批列表
type SealApprovalListResp struct {
	Paging *paging.PagingItem
	List   []*contract_approval.SealApprovalList `description:"列表数据"`
}

//SealDetailResp 审批列表
type SealDetailResp struct {
	SealDetail   *SealMoreResp                                          `description:"审批单详情"`
	FlowNodeList [][]contract_approval_record.ContractApprovalRecord `description:"审批流"`
	OpButton     OpButton                                            `description:"操作权限"`
}

type SealMoreResp struct {
	*seal.Seal
	FileUrls []string `description:"多个附件"`
}
//OpButton 合同操作按钮
type OpButton struct {
	Approval   bool `description:"是否有审批权限"`
	Invalid    bool `description:"是否有作废用印权限"`
	Edit       bool `description:"是否有编辑用印权限"`
	CheckEdit  bool `description:"审核状态下是否有编辑用印权限"`
	Cancel     bool `description:"是否有撤回用印权限"`
	UploadFile bool `description:"是否有上传签回文件权限"`
}

//RespSealList 列表数据
type RespSealList struct {
	Paging *paging.PagingItem
	List   []*seal.Seal `description:"列表数据"`
}
