package company_product_try_out_update_permission_log

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// CompanyProductTryOutUpdatePermissionLog 客户产品变更品种详情表
type CompanyProductTryOutUpdatePermissionLog struct {
	Id                        int       `orm:"column(id);pk"`
	CompanyProductUpdateLogId int       `description:"产品变更id"`
	ChartPermissionId         int       `description:"品种权限id"`
	StartDate                 time.Time `description:"开始日期"`
	EndDate                   time.Time `description:"结束日期"`
	RealEndDate               time.Time `description:"实际结束日期"`
	IsStop                    int       `description:"是否已经终止了，0：进行中；1：已终止"`
	CreateTime                time.Time `description:"创建时间"`
}

// Update 更新客户产品变更品种详情
func (item *CompanyProductTryOutUpdatePermissionLog) Update(cols []string) (err error) {
	o := orm.NewOrm()
	_, err = o.Update(item, cols...)
	return
}
