package system

import (
	"time"
)

type SysTeamAddReq struct {
	GroupId      int    `description:"大组id"`
	DepartmentId int    `description:"部门id"`
	TeamName     string `description:"分组名称,多个用英文逗号隔开"`
}

type SysTeam struct {
	GroupId      int       `orm:"column(group_id);pk" description:"分组ID"`
	ParentId     int       `description:"父级Id"`
	DepartmentId int       `description:"部门id"`
	GroupName    string    `description:"分组名称"`
	CreateTime   time.Time `description:"创建时间"`
}

type SysTeamEditReq struct {
	TeamId   int    `description:"分组ID"`
	TeamName string `description:"分组名称"`
}

type SysTeamDeleteReq struct {
	TeamId int `description:"小组ID"`
}

type SysTeamList struct {
	GroupId    int       `orm:"column(group_id);pk" json:"DepartmentId" description:"小组ID"`
	ParentId   int       `json:"GroupId" description:"小组Id"`
	GroupName  string    `json:"DepartmentName" description:"分组名称"`
	CreateTime time.Time `description:"创建时间"`
}
