package cygxService

import (
	"fmt"
	"hongze/hongze_mobile_admin/services/alarm_msg"
	"hongze/hongze_mobile_admin/utils"
	"time"
)

type YanXuanActivityPointsRedis struct {
	UserId            int       `description:"用户ID"`
	ComapnyId         int       `description:"公司ID"`
	CompanyContractId int       `description:"合同id"`
	ActivityId        int       `description:"活动ID"`
	PublishStatus     int       `description:"发布状态 1已发布，0未发布"`
	SourceType        int       `description:"1：报名、 2：取消报名、3：活动编辑、4：活动发布，取消发布、5：活动到会、6 研选审批通过的时候研选扣点更新。"`
	AdminId           int       `description:"管理员、销售ID"`
	Source            int       `description:" 来源，1客户端，2后台添加, 3开发人员手动添加、4定时任务"`
	RegisterPlatform  int       `description:"来源 1小程序，2：网页"`
	CreateTime        time.Time `description:"创建时间"`
}

// 6 研选审批通过的时候研选扣点更新
func YanXuanCompanyApproval(comapnyId, companyContractId int) (err error) {
	defer func() {
		if err != nil {
			fmt.Println(err)
			msg := fmt.Sprint("comapnyId:", comapnyId)
			go alarm_msg.SendAlarmMsg("研选审批通过的时候研选扣点更新，写入Redis队列消息失败："+err.Error()+msg, 2)
		}
	}()
	//SourceType int       `description:"1：报名、 2：取消报名、3：活动编辑、4：活动发布，取消发布、5：活动到会。6 研选审批通过的时候研选扣点更新。7,正式专试用定时任务更新"`
	log := &YanXuanActivityPointsRedis{ComapnyId: comapnyId, CompanyContractId: companyContractId, SourceType: 6, Source: 2, CreateTime: time.Now()}
	if utils.Re == nil {
		err := utils.Rc.LPush(utils.CYGX_YANXUAN_POINTS_KEY, log)
		if err != nil {
			fmt.Println("YanXuanActivityPointsRedis LPush Err:" + err.Error())
		}
	}
	return
}
