package utils

const (
	Md5Key = ""
)

// 常量定义
const (
	FormatTime            = "15:04:05"                //时间格式
	FormatDate            = "2006-01-02"              //日期格式
	FormatDateTime        = "2006-01-02 15:04:05"     //完整时间格式
	FormatDateTimeMinute2 = "2006-01-02 15:04"        //时间格式 年-月-日 时:分
	HlbFormatDateTime     = "2006-01-02_15:04:05.999" //完整时间格式
	FormatDateTimeUnSpace = "20060102150405"          //完整时间格式
	PageSize15            = 15                        //列表页每页数据量
	PageSize5             = 5
	PageSize10            = 10
	PageSize20            = 20
	PageSize30            = 30
)

const (
	APPNAME          = "随手办公"
	EmailSendToUsers = "317699326@qq.com;984198890@qq.com"
)

// 手机号，电子邮箱正则
const (
	RegularMobile = "^((13[0-9])|(14[5|7])|(15([0-3]|[5-9]))|(18[0-9])|(17[0-9])|(16[0-9])|(19[0-9]))\\d{8}$" //手机号码
	RegularEmail  = `\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*`                                             //匹配电子邮箱
)

// 验证码code
const (
	REGISTER_CODE = iota + 1 //注册
	LOGIN_CODE               //登录
)

// 聚合短信
var (
	JhGnTplId  = "65692"                            //聚合国内模板编码
	JhGjTplId  = "10054"                            //聚合国内模板编码
	JhGnAppKey = "4c8504c49dd335e99cfd7b6a3a9e2415" //聚合国内AppKey
	JhGjAppKey = "3326ad2c1047a4cd92ace153e6044ca3"
)

// 客户状态
const (
	COMPANY_STATUS_TRY_OUT         = "试用"
	COMPANY_STATUS_X_CLASS_TRY_OUT = "X类试用" //最早定义为永续
	COMPANY_STATUS_FOREVER         = "永续"
	COMPANY_STATUS_FREEZE          = "冻结"
	COMPANY_STATUS_LOSE            = "流失"
	COMPANY_STATUS_FORMAL          = "正式"
	COMPANY_STATUS_POTENTIAL       = "潜在"
	COMPANY_STATUS_TRY_OUT_COUNT   = 30

	COMPANY_APPROVE_STATUS = "待审批"
)

// 管理员，ficc管理员，ficc销售，权益管理员，权益销售。
// 角色类型/类型编码
const (
	ROLE_TYPE_ADMIN       = "管理员"
	ROLE_TYPE_FICC_ADMIN  = "ficc管理员"
	ROLE_TYPE_FICC_SELLER = "ficc销售"
	ROLE_TYPE_RAI_ADMIN   = "权益管理员"
	ROLE_TYPE_RAI_SELLER  = "权益销售"

	ROLE_TYPE_FICC_GROUP      = "ficc组长"
	ROLE_TYPE_RAI_GROUP       = "权益组长"
	ROLE_TYPE_FICC_DEPARTMENT = "ficc部门经理"
	ROLE_TYPE_RAI_DEPARTMENT  = "权益部门经理"
	ROLE_TYPE_FICC_RESEARCHR  = "ficc研究员"
	ROLE_TYPE_RAI_RESEARCHR   = "权益研究员"

	ROLE_TYPE_CODE_ADMIN           = "admin"           //管理员
	ROLE_TYPE_CODE_FICC_ADMIN      = "ficc_admin"      //ficc管理员
	ROLE_TYPE_CODE_FICC_SELLER     = "ficc_seller"     //ficc销售
	ROLE_TYPE_CODE_RAI_ADMIN       = "rai_admin"       //权益管理员
	ROLE_TYPE_CODE_RAI_SELLER      = "rai_seller"      //权益销售
	ROLE_TYPE_CODE_FICC_GROUP      = "ficc_group"      //ficc销售主管
	ROLE_TYPE_CODE_RAI_GROUP       = "rai_group"       //ficc组长
	ROLE_TYPE_CODE_FICC_DEPARTMENT = "ficc_department" //ficc部门经理
	ROLE_TYPE_CODE_RAI_DEPARTMENT  = "rai_department"  //权益部门经理
	ROLE_TYPE_CODE_FICC_RESEARCHR  = "ficc_researcher" //ficc研究员
	ROLE_TYPE_CODE_RESEARCHR       = "researcher"      //ficc研究员（最早定义的）
	ROLE_TYPE_CODE_RAI_RESEARCHR   = "rai_researcher"  //权益研究员
	ROLE_TYPE_CODE_COMPLIANCE      = "compliance"      //合规角色
	ROLE_TYPE_CODE_FINANCE         = "finance"         //财务角色
	ROLE_TYPE_CODE_FICC_TEAM       = "ficc_team"       //ficc销售组长

	ROLE_TYPE_SELLERS = "'ficc_admin','ficc_seller','rai_admin','rai_seller','ficc_group','rai_group','ficc_department','rai_department','compliance'"
)

// 客户类型
const (
	COMPANY_CLASSIFY_FICC    = "ficc"
	COMPANY_CLASSIFY_RAI     = "权益"
	COMPANY_CLASSIFY_PARTNER = "合作伙伴"
)

const (
	COMPANY_PRODUCT_FICC_ID   = 1
	COMPANY_PRODUCT_FICC_NAME = "ficc"
	COMPANY_PRODUCT_RAI_ID    = 2
	COMPANY_PRODUCT_RAI_NAME  = "权益"
)

var PermissionFiccClassifyArr = [...]string{"宏观经济", "化工产业", "建材产业", "有色产业", "新能源"}
var PermissionAllClassifyArr = [...]string{"宏观经济", "化工产业", "建材产业", "有色产业", "新能源", "权益"}

// 缓存key
const (
	CACHE_KEY_LOGS                      = "HZ_ADMIN_CACHE_KEY_LOGS" //api用户操作日志队列
	CACHE_KEY_ADMIN                     = "calendar:admin:list"     //系统用户列表缓存key
	CACHE_KEY_ADMIN_ID                  = "calendar:admin:id:list"  //系统用户列表缓存key
	HZ_MOBILE_ADMIN_WXLOGIN_TOKEN       = "hz_mobile_admin:wxLogin:admin_token:"
	HZ_MOBILE_ADMIN_WXLOGIN_MOBILE_CODE = "hz_mobile_admin:wxLogin:mobile_code:"
	HZ_ADMIN_WX_ACCESS_TOEKN            = "hz_admin:wx:access_token:"
	CACHE_KEY_SHANG_HAI_RS_CALENDAR_API = "hz_crm_shang_hai_rs_calendar_api" //上海研究员日历同步队列
)

// 微信用户user_record注册平台
const (
	USER_RECORD_PLATFORM_RDDP      = iota + 1 // 日度点评公众号
	USER_RECORD_PLATFORM_BACKSTAGE            // 管理后台
	USER_RECORD_PLATFORM_PC                   // PC端网站
	USER_RECORD_PLATFORM_CYGX                 // 查研观向小程序
	_
	USER_RECORD_PLATFORM_YB // 研报小程序
)

// 模板消息推送类型
const (
	TEMPLATE_MSG_REPORT                = iota + 1 //日度点评报告推送
	TEMPLATE_MSG_INDEX                            //指标更新
	TEMPLATE_MSG_APPLY                            //审批通知
	TEMPLATE_MSG_RECEIVE                          //销售领取客户通知
	TEMPLATE_MSG_CYGX_ACTIVITY_CACLE              //查研观向活动取消通知
	TEMPLATE_MSG_CYGX_ACTIVITY_UPDATE             //查研观向活动更改时间通知
	TEMPLATE_MSG_CYGX_ARTICLE                     //关注的作者发布报告通知
	TEMPLATE_MSG_CYGX_DAY_REPORT                  //发送日报（周报、双周报、月报）
	TEMPLATE_MSG_ACTIVITY_APPOINTMENT             //活动预约/报名时间通知
	TEMPLATE_MSG_RECEIVE_PERMISSION               //销售"添加客户/领取客户"权限变更通知
	TEMPLATE_MSG_YB_COMMUNITY_QUESTION            //研报问答社区
	TEMPLATE_MSG_CYGX_ACTIVITY_ADD                //查研观向小程序活动更新推送 12
	TEMPLATE_MSG_CYGX_ARTICLE_ADD                 //查研观向报告更新推送  13
	TEMPLATE_MSG_YB_PRICE_DRIVEN                  //研报价格驱动 14
	TEMPLATE_MSG_SEAL_FINISHED                    //用印申请已迁回通知 15
	TEMPLATE_MSG_YB_COMMUNITY_VIDEO               //研报视频社区 16
	TEMPLATE_MSG_MOVE_SELLER                      //销售"移动/删除联系人"权限变更通知 17
	TEMPLATE_MSG_YB_VOICE_BROADCAST               //研报语音播报 18
	TEMPLATE_MSG_YB_VIDEO_UPLOAD                  //研报视频上传 19
	TEMPLATE_MSG_YB_ROAD_VIDEO                    //研报线上路演 20
	TEMPLATE_MSG_CYGX_ROADSHOW_VIDEO              //查研观向微路演视频 21
)

const (
	SendTemplateMsgAuthorization = "dc855fce962a639faa779cbdd4cd332f"
)

const (
	LU_YAN_FU_WU                            = "路演服务"
	CHART_PERMISSION_ID_YANXUAN             = 31
	YAN_XUAN_KOU_DIAN_BAO_ID         int    = 52 //研选扣点包ID
	CE_LUE_NAME                      string = "策略"
	YI_YAO_NAME                      string = "医药"
	XIAO_FEI_NAME                    string = "消费"
	KE_JI_NAME                       string = "科技"
	ZHI_ZAO_NAME                     string = "智造"
	CHART_PERMISSION_NAME_MF_YANXUAN string = "研选订阅"
	ZHUAN_JIA_ID                     int    = 29
	CHART_PERMISSION_NAME_70W               = "70w大套餐"                // 权益70w大套餐名称
	CHART_PERMISSION_ID_70W                 = 2001                       // 权益70w大套餐表示的权限ID(自定义)
	CHART_PERMISSION_NAME_45W               = "45w大套餐"                // 权益45w大套餐名称
	CHART_PERMISSION_ID_45W                 = 2002                       // 权益45w大套餐表示的权限ID(自定义)
	TPL_MSG_WANG_YANG                       = "tpl_msg_wang_yang"        //汪洋手机号地址参数
	TPL_MSG_YANXAUN_APPROVAL                = "tpl_msg_yanxaun_approval" // 【研选订阅】和【研选扣点包】转正/续约审批通过后，给冯柯然和汪洋和沈涛发送模板消息
)

const (
	CYGX_YANXUAN_POINTS_KEY string = "CYGX_YANXUAN_POINTS_KEY" //查研观向研选活动扣点KEY
)

const (
	ApproveUserId = 9 //戚明之-出差审批人
)
